 UNIT MaSouris;

INTERFACE
Uses Dos;
(* UNITE de gestion de la souris Microsoft Mic** 2007 *)

{ Remerciement aux EDITIONS WEKA pour le cours
 "Programation et modles de programmes en Turbo-Pascal"
  publis en 1989
   Marc MANERU PASCALISSIME N 50
   Yves GUITTARD pour les autres procdures                            }


PROCEDURE Mouse(var P1, P2, P3, P4 : Integer);
{- - - - - - - - - - - - - - - - - - - }
{ Interfaage avec la souris Microsoft }
{- - - - - - - - - - - - - - - - - - - }
PROCEDURE Init_Mouse;
{- - - - - - - - - - - - - - -}
{ Initialisation de la souris }
{- - - - - - - - - - - - - - -}
PROCEDURE Show_Mouse;
{- - - - - - - - - - - - - - - - - - - - }
{ Validation de l'affichage de la souris }
{- - - - - - - - - - - - - - - - - - - - }
PROCEDURE Hide_Mouse;
{- - - - - - - - - - - - - - - - - - - - - }
{ Dvalidation de l'affichage de la souris }
{- - - - - - - - - - - - - - - - - - - - - }
PROCEDURE Pos_Mouse(VAR Button,X,Y : Integer);
{- - - - - - - - - - - - - - - - - - -}
{ Lecture de la position de la souris }
{- - - - - - - - - - - - - - - - - - -}
PROCEDURE Bout_Relache(ButtonR,X,Y,Dr,Gr,Nbp : Integer);
{-------------------------------}
{ tat de la souris lors du     }
{ relachement d'un bouton donn }
{-------------------------------}
PROCEDURE Set_Mouse(VAR X,Y : Integer);
{- - - - - - - - - - - - - - - - - - - - - - }
{ Initialisation de la position de la souris }
{- - - - - - - - - - - - - - - - - - - - - - }
PROCEDURE MouseXPosMinMax;
{- - - - - - - - - - - - - - - - - - - - - - }
{ Dfinit une fentre Xmin,Xmax de la souris }
{- - - - - - - - - - - - - - - - - - - - - - }
PROCEDURE MouseYPosMinMax;
{- - - - - - - - - - - - - - - - - - - - - - }
{ Dfinit une fentre Ymin,Ymax de la souris }
{- - - - - - - - - - - - - - - - - - - - - - }


IMPLEMENTATION

Var
X,Y,P1,P2,P3,P4             : Integer;
MinX,MaxX,MinY,MaxY         : Integer;
Regs                        : Registers;{ Registres du microprocesseur }
l,c,b                       : String;

PROCEDURE Mouse(var P1, P2, P3, P4 : Integer);
begin
  With Regs do { Valeur en entre des registres }
  begin
    AX:=P1;
    BX:=P2;
    CX:=P3;
    DX:=P4;
  end;
  Intr($33,Regs);
    With Regs do  { Valeur en sortie des registres }
  begin
    P1:=AX;
    P2:=BX;
    P3:=CX;
    P4:=DX;
  end;
end;


PROCEDURE Init_Mouse;
begin
  P1:=0;
  P2:=0;
  P3:=0;
  P4:=0;
  Mouse(P1,P2,P3,P4);
end;


PROCEDURE Show_Mouse;
begin
  P1:=1;
  P2:=0;
  P3:=0;
  P4:=0;
  Mouse(P1,P2,P3,P4);
end;


PROCEDURE Hide_Mouse;
begin
  P1:=2;
  P2:=0;
  P3:=0;
  P4:=0;
  Mouse(P1,P2,P3,P4);
end;


PROCEDURE Pos_Mouse(VAR Button,X,Y : Integer);
begin
  P1:=3;
  P2:=0;
  P3:=0;
  P4:=0;
  Mouse(P1,Button,X,Y);
  str(X,l); {convertit x en chaine pour affichage en mode graphique }
  str(Y,c); {y en chaine c}
  str(Button,b); {Button en chaine b}
end;

PROCEDURE Bout_Relache(ButtonR,X,Y,Dr,Gr,Nbp : Integer);
Var
Result :Integer;
Begin
  P1:= $06;
  P2:=ButtonR;
  P3:=0;
  P4:=0;
  Mouse(P1,P2,P3,P4);
  Result := P1 And $01;                     { isolement Bit 0 }
  If Result = 0 then Gr := 0 else Gr :=1;   { Bouton gauche relach ou non  }
  Result := P1 And $02;                     { isolement Bit 1 }
  If Result = 0 then Dr := 0 else Dr :=1;   { Bouton droit relach ou non   }
  Nbp := P2;                                { Nombre de pressions du bouton }
  X := P2;
  Y := P3;
  str(X,l); {convertit x en chaine pour affichage en mode graphique }
  str(Y,c); {y en chaine c}
  str(ButtonR,b); {Button en chaine b}
  End;

PROCEDURE Set_Mouse(VAR X,Y : Integer);
begin
  P1:=4;
  P2:=0;
  P3:=X;
  P4:=Y;
  Mouse(P1,P2,P3,P4);
end;

(* Nom: MouseXPosMinMax ->  Dfinir les positions horizontales minimale *)
(*                          et maximale de la souris                    *)
(* Paramtres envoys : MinX (integer) : position minimale              *)
(*                      MaxX (integer) : position maximale              *)

procedure MouseXPosMinMax;

begin { MouseXPosMinMax }
      P1 := 7;
      P2 := 0;
      P3 := MinX;
      P4 := MaxX;
      Mouse(P1,P2,P3,P4);
end;   { MouseXPosMinMax }

(* Nom: MouseYPosMinMax ->  Dfinir les positions verticales minimale   *)
(*                          et maximale de la souris                    *)
(* Paramtres envoys : MinY (integer) : position minimale              *)
(*                      MaxY (integer) : position maximale              *)

procedure MouseYPosMinMax;

begin { MouseYPosMinMax }
     P1  := 8;
     P2  := 0;
     P3  := MinY;
     P4  := MaxY;
      Mouse(P1,P2,P3,P4);
end;   { MouseYPosMinMax }


END.