Program MySlide;  { By Mic**  26/09/2007 mic-josi@orange.fr}
                  { A modifier ou  copier sans restriction }

Uses Crt,Graph,Dos;

Type
  LED = Record        { Enregistrement des coordonnes et couleurs des LED }
        LedX: Array[1..4096] of  Byte; { Tableau binaire X des LEDs rouges }
        LedY: Array[1..4096] of  Byte; { Tableau binaire Y des LEDs vertes }
        End;
  Var
  L : LED;                                           { variable du type LED }
  Nom : String;                                 { Nom du fichier  projeter }
  Slide  : Text;                    { Stockage des tableaux dans un fichier }
  x,y,et,tranche,xy :Integer;        { variables utilises dans les boucles }
  Ap : Boolean;                  { Drapeau premire ouverture fichier Slide }
  DeciR8,DeciV8,Dec2Bin : Byte;{ Octet de transfert R8 ou  V8 rouge ou vert }

  Const
  CoX: Array[1..8] of integer=
  (30,54,78,102,126,150,174,198);                         {Centre X des LEDs}
  CoY: Array[1..8] of integer=
  (50,74,98,122,146,170,194,218);                         {Centre Y des LEDs}

{=========================================================================}
{ inclusion du pilote EGAVGA directement dans le programme excutable }
procedure EGAVGAdriverProc; external;
{$L PEGAVGA.OBJ}
{=========================================================================}
procedure Init_VGA;                          { Initialisation du mode VGA }
 Var
 GraphPilote, GraphMode,error,init :Integer;
 Begin
 Init := RegisterBGIdriver(@EGAVGAdriverProc);
         GraphPilote := VGA;
         GraphMode := VGAHI;             { Mode VGA 640 x 480 16 couleurs }
 InitGraph (GraphPilote,GraphMode,'');{ Plus besoin du chemin pour la BGI }
 error := GraphResult;
 if(error <> 0) Then Begin
     Writeln ('Erreur Graphique ',GraphErrorMsg(error));
     readln;
 end;
SetViewPort(190,90,410,360,ClipOn); { rserve une fentrte au centre
                                          de l'cran pour le ShowLEDs     }
End;
{=========================================================================}
function Coul (cou:Integer):Integer; { Slection d'une couleur }
Begin
 SetColor(cou);
End;
{=========================================================================}
Procedure Bin(D_B:Byte;R :Boolean);  (* Dcimal vers Binaire *)
var
c,i,ii        :Byte;
begin
c:= Dec2Bin;
for ii := 8 downto 1 do
 begin
 i:=ii;
 i :=(c*2) shr i and 1;
 Inc(xy);
 { si R = vrai le bit dcod va dans le tableau des LEDs rouges
     sinon il va dans le tableau des LEDs vertes                 }
 if R = true then  L.LedX[xy] := i Else L.LedY[xy] := i;
 end;
If R = true Then xy := xy - 8; { saute les Bits des LEDs vertes }
end;

{=========================================================================}
procedure LitShow; { Lecture du fichier Slide.Txt avant conversion }
Var
TL :Byte;
NomImag:String;
Begin
Repeat
 ReadLn(Slide,NomImag);
 For TL := 1 to 8 do
 Begin
 ReadLn(Slide,DeciR8);   { lit le  chiffre dcimal des LEDs rouges }
 Dec2Bin := DeciR8;      { transfert dans Bin2Dec }
 Bin(DeciR8,True);       { appel procedure de dcimal en binaire   }
 ReadLn(Slide,DeciV8);   { lit le  chiffre dcimal des LEDs vertes }
 Dec2Bin :=DeciV8;
 Bin(DeciV8,False);                     { drapeau rouges ou vertes }
 End;
Until xy = 2048;         { limite 2048 tranche de 64 LEDs          }
End;

{=========================================================================}
procedure LedPaint(et:Byte; x,y:Integer);
{ (et) couleur (x y) coordonnes du pixel  peindre }
Begin;
    Case et of
      2: Begin
         SetFillStyle(1,2);
         Floodfill(x,y,2);
         End;
      4: Begin
         SetFillStyle(1,4);
         Floodfill(x,y,4);
         End;
      8: Begin
         SetFillStyle(1,8);
         Floodfill(x,y,8);
         End;
  End;
End;

procedure Gris_Rouge(tranche:integer);{ peint en rouge vert ou gris les LEDs }

Var
LumBitX,LumBitY : Byte;
Lum             : Integer;
Begin
Lum := 0;LumBitX := 1;LumBitY := 1 ;
For Lum := 1 + tranche to 64 + tranche do
 Begin
 If L.LedY[Lum] = 1 Then et := 2  Else  if et <> 4 then et := 8;{ LEDs vertes }
 If L.LedX[Lum] = 1  Then et := 4 Else  if et <> 2 then et := 8;{ LEDs rouges }
      Case et of
              4 : Coul(4);
              2 : Coul(2);
              8 : Coul(8);
      end;

      x:= CoX[LumBitY];
      y := CoY[LumBitX];
      Circle(x,y,9);
      LedPaint(et,x,y);
       {delay(10);  dlai d'affichage entre deux lignes facultatif }
      Inc(LumBitY);
      if LumBitY  > 8 then                    { 8 LEDs affiches ? }
          Begin
          LumBitY := 1;                   { alors retour colonne 1 }
          Inc (LumBitX);               { et passage ligne suivante }
          If LumBitX  > 8 Then LumBitX := 1;
          End;
  End;
delay(250);
End;
{=========================================================================}

{***************************************************************************}
                {   ****** PROGRAMME PRINCIPAL ****** }
BEGIN
  ClrScr;
  GotoXY (20,20);
  Nom := ParamStr (1); { y a t'il le nom dans la ligne de commande du DOS ? }
  if Nom ='' then                                               { Non alors }
  Begin
  write ('Nom du fichier  projeter sans extention ? :  ');
  readln (Nom);
  End;
  Nom := Nom + '.txt';    { on ajoute l'extension .txt }

 Tranche := 0;
 Init_VGA;          { passage en mode graphique VGA 16 couleurs }
 Assign(Slide,Nom);     { ouverture du fichier des LEDs }
 Reset(Slide);                  { pointe sur le premier octet   }
 LitShow;
 delay(500);
 repeat
 Gris_Rouge(tranche);    { affichage des LEDs par tranche de 64 }
 tranche := tranche + 64 ;                { incrmente tranche  }

{ ClearViewPort;  efface l'cran entre deux tranches facultatif }

 delay(50);              { dlai entre deux tranches facultatif }
 Gris_Rouge(tranche);                        { tranche suivante }
 if tranche = 704 then tranche:= 0;{ boucle jusqu'a tranches  0 }
 Until (tranche = 4096) or Keypressed;
 CloseGraph;                                { retour mode texte }
 Close(Slide);                  { fermeture du fichier des LEDs }

END.                  { Fin du programme principal }


