(* +------------------------------------------------+ *)
(* !    Unit  Permettant de visualiser des         ! *)
(* !    Images BMP exclusivement en 256 Couleurs    ! *)
(* !                                                ! *)
(* !Modification du programme de M. Ainardi  Florent! *)
(* ! Ecrit Pour:  REPONSE MICRO n12                ! *)
(* ! Config :  Tout Type de PC munie d'une carte    ! *)
(* !              SVGA Compatible mode VESA ou MCGA ! *)
(* !              Turbo pascal 7.0                  ! *)
(* ! Ajout du mode VESA par Mic**                   ! *)
(* ! Date:         01/01/2001                       ! *)
(* ! REM : Hlas cette fabuleuse revue n'existe plus! *)
(* +------------------------------------------------+ *)

Unit VesaSapU;
INTERFACE

uses
Crt, Dos;

var
  regs                : Registers;
  r,g,b,i,j,xm,ym     : Integer;
  value,mode          : Integer;
  x,y,pi,ps,xmax,ymax : Integer;
  f                   : Text;
  c                   : Char;
  reponse             : String;
  coul                : Word;
  test                :boolean;

procedure texte;{ mode texte }
procedure vesa(mode:integer); { mode MCGA ET VESA }
procedure press_key;
procedure prepare;
procedure rectif_palette;
procedure aff(xg,yg: integer;co : byte);
procedure lit_image;

IMPLEMENTATION
(* -------------------------------------------- *)
(* ------- Procedure d'init. mode texte ------- *)
(* -------------------------------------------- *)

procedure texte;
begin
 with regs do
  begin
    ah:=00;
    al:=$03;
    intr($10,regs);
  end;
end;


(* -------------------------------------------- *)
(*  Procedure d'init. mode VESA Writed By ZaMi  *)
(* -------------------------------------------- *)

procedure vesa(mode:integer);
{=================================================
 15 bits mode    Rsolution  Couleurs
 100h            640x400     256
 101h            640x480     256
 102h            800x600      16
 103h            800x600     256
 104h            1024x768     16
 105h            1024x768    256
 106h            1280x1024    16
 107h            1280x1024   256
 ===================================================================
 Fonctions VESA de l'interruption 10h
 ===================================================================
 -------------------------------------------------------------------
 Fonction 02h Slectionne le mode Super VGA
 Entre:     AH =4Fh   Support Super VGA
             AL =02h   slectionne
             BX = Vido mode   (D0-D14 vido mode
                                D15 =0 clear mmoire vido
                                D15 =1 pas de clear mmoire vido)
 Sortie:     AX = Status
 ------------------------------------------------------------------
Fonction 03h Renvoie le mode Super VGA
 Entre:     AH =4Fh   Support Super VGA
             AL =03h   Quel le mode vido atuel ?

 Sortie:     AX = Status
             BX = Mode vido actuel
 ------------------------------------------------------------------

==================================================================}
begin
 with regs do
  begin
    ah:=$4F;
    al:=$02;
    bx:=mode;
    intr($10,regs);
  end;
end;

(* -------------------------------------------- *)
(* ------- procdure de test de touche -------- *)
(* -------------------------------------------- *)

procedure press_key;
begin
 repeat
 Reponse :=ReadKey;
 until Reponse <> '';
end;

(* -------------------------------------------- *)
(* ------- Procedure lecture dimension -------- *)
(* -------------------------------------------- *)

procedure prepare;
begin

 (* identification du type d'image BMP *)

 for i:=1 to 13 do
   read(f,c);

 (* dimension X *)

 read(f,c);
 pi:=ord(c);
 read(f,c);
 ps:=ord(c);
 xmax:=ps*256+pi;

 for i:=1 to 2 do
    read(f,c);

 (* dimension Y *)

 read(f,c);
 pi:=ord(c);
 read(f,c);
 ps:=ord(c);
 ymax:=ps*256+pi;

 (* selection automatique du mode graphique *)
 (* en fonction des dimensions de l'image   *)

 ym:=200;
 xm:=320;
 vesa(19); {MCGA 320x200}

 (* resolution 640 x 480 *)
 if (xmax>=321) or (ymax>=201) then
 begin
 xm:=640;
 ym:=480;
 vesa($101);
 End;
 (* resolution 800 x 600 *)
 if (xmax>=641) or (ymax>=481) then
 begin
 xm:=800;
 ym:=600;
 vesa($103);
 End;

 (* resolution 1024 x 768 *)
 if (xmax>=801) or (ymax>=601) then
   begin
    xm:=1024;
    ym:=768;
    vesa($105);
   end;

 for i:=1 to 30 do
  read(f,c);
end;

(* -------------------------------------------- *)
(* -------- Procedure lecture palette --------- *)
(* -------------------------------------------- *)

procedure rectif_palette;
begin
  with regs do
    begin
      for i:=0 to 255 do
       begin
        ah:=$10;
        al:=$10;
        bx:=i;
        read(f,c);
        b:=ord(c) div 4;
        read(f,c);
        g:=ord(c) div 4;
        read(f,c);
        r:=ord(c) div 4;
        read(f,c);
        ch:=g;
        cl:=b;
        dh:=r;
        intr($10,regs);
      end;
  end;
end;

(* -------------------------------------------- *)
(* --------- Procedure affiche point ---------- *)
(* -------------------------------------------- *)

procedure aff(xg,yg: integer;co : byte);
begin
  with regs do
   begin
     ah:=$c;
     al:=co;
     cx:=xg;
     dx:=yg;
     bh:=0;
   intr($10,regs);
   end;
end;

(* -------------------------------------------- *)
(* --------- Procedure lecture image ---------- *)
(* -------------------------------------------- *)

procedure lit_image;
begin
 x:=0;
 y:=ymax;
 repeat
  repeat
   read(f,c);
   coul:=ord(c);
   aff(x,y,coul);
   inc(x);
  until x=xmax;
  x:=0;
  dec(y);
 until y=0;
end;

End.
